/////////////////////////////////////////////////////////////////
//Nichtlineares dynamisches System: Standard-Map periodisch/chaotisch
//x-Schnitte durch Standard-Map mit Lyapunov-Koeffizient
//////////////////////////////////////////////////////////////


//Bildausschnitt zu Beginn:
double xU = 0; double yU = 0  ;
double xO = 1; double yO = 1;

//Zwischenspeicher:
double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
double xAlt, yAlt, xNeu, yNeu, xH, yH; //Parameter für Iteration Punkt 1
double xAlt1,yAlt1,xNeu1,yNeu1,xH1, yH1; //Parameter für Iteration Punkt 2
boolean zeichnen;
PFont font;
int n;//Anzahl Punkte pro Iteration
int xK, yK;//Koordinaten der Punkte
color farbe;
String s;
double K;
double D = 0.00000001; //kein Problem bei double-Rechnungen
double abstandAlt, abstandNeu;
//int aK ; // Abstand in y-Koordinaten
//int aNull;
//double delta;
int Z; //ab Z wird gezeichnet
double lambda;
int lambdaKNeu, lambdaKAlt;
int j;
float rot, gelb, blau, tuerkis;
float faktorRot, faktorBlau, faktorGelb, faktorTuerkis;
float tempMin, tempMax;

//Initialisierungen  
void setup(){ 
  size(640,640);
  strokeWeight(1); 
  background(0); 
  colorMode(RGB,256,256,256);
   //K  = 1.4;
  //K = 0.5;//lternativer K-Wert
  K=0.971635;//Parameter der Tschirikow-Tayler-Standardabbildung 

  n= 1000;  //n...Anzahl der Iterationen
  Z = 100;// Ab Z wird der Abstand der beiden Punkte berechnet
 
  xH = xU; 
  yH = yU;
  tempMin=0; tempMax=0;
  xUNeu = 0; xONeu = 0;
  yUNeu = 0; yUNeu = 0;
  abstandNeu =0; abstandAlt =0;
  lambda =0;  
  zeichnen = true;
  j=0;
  rot = 0; gelb =0; blau =0; tuerkis =0;
  faktorRot =36;
  faktorBlau= 500;
  faktorGelb = 30;
  faktorTuerkis = 400;
}
/////////////////////////////////////////////////////////////////////// 
 void draw(){  

 if (zeichnen){  
    
   for(int i=0; i<width;i++){
     xH = map(i,0,width,(float)xU,(float)xO);
     iteriere(xH,yH,i,j); 
   
   }
   j++;
   yH = map(j,height,0,(float)yU,(float)yO);
   // println(yH); 
    if(yH <= D) {zeichnen = false; println("fertig!");}
 }
}

//////////////////////////////////////////////////////////
//Eine erste Iteration wird im setup() ausgelöst
////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int I, int J){  
 
   int i=0;
 
   xAlt = xH; xAlt1 = xH + D;
   yAlt = yH; yAlt1 = yH ;
   
 
  while(i <=n){ 
    
     yNeu = (yAlt + K*Math.sin(2*Math.PI*xAlt)/(2*Math.PI));// % 1; 
     xNeu = (xAlt + yNeu);       

     
     yNeu1 = (yAlt1 + K*Math.sin(2*Math.PI*xAlt1)/(2*Math.PI));// % 1; 
     xNeu1 = (xAlt1 + yNeu1) ;
     
    
     if(i >= Z){
       abstandNeu = sqrt(sq((float)(xNeu-xNeu1))+sq((float)(yNeu-yNeu1))); 
       //abstandNeu = Math.abs(xNeu-xNeu1);//Alternative
     
       if((abstandNeu-abstandAlt)/D !=0)
       lambda = lambda+Math.log(Math.abs(abstandNeu-abstandAlt)/D);
       abstandAlt = abstandNeu;
     } 
     xAlt = xNeu;
     yAlt = yNeu; 
     xAlt1 = xNeu1;
     yAlt1 = yNeu1; 
     i++; 
  }
   i=0;  
       lambda = lambda/(n-Z);//println(lambda);   
    
    
   stroke(faerben(lambda));     
   point(I,J);
   
}
////////////////////////////////////////////////////////////////////
color faerben(double Lambda){
   if(Lambda > 0){
          rot = (faktorRot*(float)Lambda);
          if(rot>255){
             gelb = (faktorGelb*(float)Lambda)-256;
             rot = 255;
          }else {
            gelb =0;
          } 
         farbe = color(rot,gelb,0); //Da "gelb" != 0 nur wenn rot =255 wirkt der grüne Farbton wie orange/gelb 
        }else {        
           blau = faktorBlau*sqrt(-1*(float)Lambda);
           if(blau>255){
               tuerkis = (faktorTuerkis*sqrt(-1*(float)Lambda))-256;
               if(tuerkis>255) tuerkis =255;
               blau =255;
           }else{
             tuerkis =0;
           }
           farbe = color(0,tuerkis,blau);//Da "tuerkis" != 0 nur wenn blau =255 wirkt der grüne Farbton wie türkis
        } 
  return farbe;
}

/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 5-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() {  
  
   if (mouseButton == RIGHT){
        background(0);
        j=0;
        //xK=0; 
        xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
        xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
        xU = xUNeu; xO = xONeu; 
       // xH = xU;
        yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
        yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
        yU =yUNeu; yO = yONeu; 
       // yH = yU;
        println(xU,yU);
       // delta = (yO-yU)/height;//anpassen der Schrittweite
        zeichnen = true; 
   }
}
///////////////////////////////////////////////////////////////
//Mögliche Aktionen für Farb-, K- und n-Änderung
/////////////////////////////////////////////////////////////////
void keyPressed() {
   if (key == 'r'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      faktorRot = faktorRot + 10;
      println("Faktor Rot: "+ faktorRot);
      zeichnen = true; 
   }
   if (key == 'R'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      if(faktorRot>=6) faktorRot = faktorRot - 5;
        else println("Minimum bereits erreicht!");
       println("Faktor Rot: "+ faktorRot);
      zeichnen = true; 
   }
    if (key == 'b'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      faktorBlau = faktorBlau + 100;
       println("Faktor Blau: "+ faktorBlau);
      zeichnen = true; 
   }
   if (key == 'B'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      if(faktorBlau>=51)faktorBlau = faktorBlau - 50;
        else println("Minimum bereits erreicht!");
      println("Faktor Blau: "+ faktorBlau);
      zeichnen = true; 
   }
     if (key == 'g'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      faktorGelb = faktorGelb + 10;
      println("Faktor Gelb: "+ faktorGelb);
      zeichnen = true; 
   }
   if (key == 'G'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      if(faktorGelb>= 6)faktorGelb = faktorGelb - 5;
      else println("Minimum bereits erreicht!");
      println("Faktor Gelb: "+ faktorGelb);
      zeichnen = true; 
   }
    if (key == 't'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      faktorTuerkis = faktorTuerkis + 100;
      println("Faktor Türkis: "+ faktorTuerkis);
      zeichnen = true; 
   }
   if (key == 'T'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      if(faktorTuerkis>=51)faktorTuerkis = faktorTuerkis - 50;
      else println("Minimum bereits erreicht!");
      println("Faktor Türkis: "+ faktorTuerkis);
      zeichnen = true; 
   }
   if (key == '+'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      K = K + 0.1;
      println("K =  "+ K);
      zeichnen = true; 
   }
   if (key == '-'){
      background(0);
      xH = xU; 
      yH = yU;
      xUNeu = 0; xONeu = 0;
      yUNeu = 0; yUNeu = 0;
      abstandNeu =0; abstandAlt =0;
      lambda =0;
      j=0;
      if(K>=0.2)K = K - 0.1;
      else println("Minimum bereits erreicht!");
      println("K =  "+ K);
      zeichnen = true; 
   }
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
  
  
}
